/*
 * Renderer.h
 *
 * Copyright (C) 2009 Matthias Schiffer <matthias@gamezock.de>
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ZOOM_RENDERER_H_
#define ZOOM_RENDERER_H_

namespace Zoom {

class Triangle;
class BSPTree;

class Renderer {
  public:
    void render(const BSPTree &tree);

  private:
    static void renderTriangle(const Triangle &t);

    struct RenderVisitor {
        void operator() (const Triangle &t) const {
          renderTriangle(t);
        }
    };

    static const RenderVisitor renderVisitor;
};

}

#endif /* ZOOM_RENDERER_H_ */
